#include <iostream>
#include <vector>
#include <cmath>
#include <iomanip>

#define sqr(x) ((x)*(x))

using namespace std;

struct Point {
	long long x, y;
	
	Point() {}
	Point(long long _x, long long _y) : x(_x), y(_y) {}
	
	Point operator- (const Point &a) {
		return Point(x - a.x, y - a.y);
	}
	
	long long dist2() {
		return sqr(x) + sqr(y);
	}
	
	double dist() {
		return sqrt(dist2());
	}
};

int main() {
	int n;
	cin >> n;
	
	long long mx2 = 0;
	double ans = 0, mx = 0;
	Point prev, f;
	for (int i = 0; i < n; i++) {
		Point p;
		cin >> p.x >> p.y;
		if (i == 0) f = p;
		else {
			ans += (p - prev).dist();
			if (mx2 < (p - prev).dist2()) {
				mx2 = (p - prev).dist2();
				mx = (p - prev).dist();
			}
		}
		prev = p;
	}
	
	ans += (f - prev).dist();
	if (mx2 < (f - prev).dist2()) {
		mx2 = (f - prev).dist2();
		mx = (f - prev).dist();
	}
	
	cout.precision(9);
	cout << fixed << ans - mx;
	
	return 0;
}